// PrintJobDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PrintJob.h"
#include "PrintJobDlg.h"
#include "QPrint.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPrintJobDlg dialog

CPrintJobDlg::CPrintJobDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPrintJobDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPrintJobDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPrintJobDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPrintJobDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPrintJobDlg, CDialog)
	//{{AFX_MSG_MAP(CPrintJobDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPrintJobDlg message handlers

BOOL CPrintJobDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPrintJobDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPrintJobDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPrintJobDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
 CQPrint  prt;
 HPRIVATEFONT   hFont,hFont1,hFont2;
 CSize  dim;
 CRect  margins;
  
 

  // initializing the class and printer selection
  if (prt.Dialog() == -1)
	  return;

  // create the print document in the spooler
  prt.SetPageOrientation (DMORIENT_PORTRAIT);
  prt.StartPrint();


  // Adding the arial font to the class
  hFont = prt.AddFontToEnvironment("Arial Greek",8,8);
  hFont1 = prt.AddFontToEnvironment("Arial Greek",9,9);
  hFont2 = prt.AddFontToEnvironment("Arial Greek",10,10);

  prt.SetMargins(40,160,200,200);
  prt.SetDistance(5);  

  prt.GetDrawDimension(dim);
  prt.GetMargins(margins);
  prt.SetHPos(dim.cy-margins.top);
  // activate a header and footer line
  prt.SetActiveFont (hFont);
  prt.ActivateHF(HeaderFooter);



  // set margins and line spacing
  
  prt.StartPage();
  // start printing the lines
  
 
  prt.Print(hFont,"Set Font Arial Size = 8",FORMAT_NORMAL);    
  prt.Print(hFont,"My name is George Papaioannou",FORMAT_NORMAL);
  prt.Line (PS_SOLID);


  prt.Print(hFont1,"Set Font Arial Size = 9",FORMAT_NORMAL);    
  prt.Print(hFont1,"My name is  George Papaioannou",FORMAT_NORMAL);
  prt.Line (PS_SOLID);


  prt.Print(hFont2,"Set Font Arial Size = 10",FORMAT_NORMAL);  
  prt.Print(hFont2,"My name is  George Papaioannou",FORMAT_NORMAL);
  prt.Line (PS_SOLID);



  // ===================== TABLE 1 ==========================

  prt.lf(hFont2);
  prt.lf(hFont2);
  prt.Print(hFont2,"TABLE 1",FORMAT_CENTER);  
  prt.lf(hFont2);
  prt.lf(hFont2);


  int size[5];
  size[0]=800;
  size[1]=400;
  size[2]=400;
  size[3]=400;
  

  
  prt.SetTableColumnsSize(3,size);
  prt.SetTableHorLine (TRUE);
  prt.SetTableVerLine (TRUE);
  prt.SetTableBorderSize (200);
  prt.SetTableJustify(FORMAT_CENTER);
  prt.SetTableBorderLine(5);
  //set the headers
  prt.SetFace (hFont,FACE_NORMALBOLD);
  prt.AddTableRecord (hFont,"NAME|GRADE|CITY",FORMAT_CENTER);
  //set the records
  prt.SetFace (hFont,FACE_NORMAL);
  prt.AddTableRecord (hFont,"George Papaioannou|Grade A|Lives at Athens (Greece)",FORMAT_CENTER);
  prt.AddTableRecord (hFont,"Kostas Papadimitriou|Grade B|Lives at Larissa (Greece)",FORMAT_CENTER);

  prt.lf(hFont2);
  prt.lf(hFont2);

  prt.Print(hFont2,"AppWizard has created this PrintJob application for you.  This application "
				   "not only demonstrates the basics of using the Microsoft Foundation classes "
				   "but is also a starting point for writing your application.",FORMAT_NORMAL);



  // ===================== TABLE 2 ==========================
  prt.lf(hFont2);
  prt.lf(hFont2);
  prt.Print(hFont2,"TABLE 2",FORMAT_CENTER); 
  prt.lf(hFont2);
  prt.lf(hFont2);  


  size[0]=800;
  size[1]=400;
  size[2]=600;
  size[3]=600;
  
  prt.SetTableReset();  
  prt.SetTableColumnsSize(4,size);

  //set the headers
  prt.SetFace (hFont,FACE_NORMALBOLD);
  prt.AddTableRecord (hFont,"NAME|GRADE|CITY|ADDRESS",FORMAT_CENTER);
  //set the records
  prt.SetFace (hFont,FACE_NORMAL);
  prt.AddTableRecord (hFont,"George Papaioannou|Grade A|Athens (Greece)|23 Octobriou",FORMAT_CENTER);
  prt.AddTableRecord (hFont,"Kostas Papadimitriou|Grade B|Larissa (Greece)|Irron Polytechneiou",FORMAT_CENTER);


 // =================== TABLE 3 ==============================
  prt.lf(hFont2);
  prt.lf(hFont2);
  prt.Print(hFont2,"TABLE 3",FORMAT_CENTER);  
  prt.lf(hFont2);
  prt.lf(hFont2);

  size[0]=800;
  size[1]=400;
  size[2]=600;
  size[3]=600;
  
  prt.SetTableReset();  
  prt.SetTableColumnsSize(4,size);
  prt.SetTableHorLine (TRUE);  
  prt.SetTableBorderSize (200);
  prt.SetTableJustify(FORMAT_RIGHT);


  //set the headers
  prt.SetFace (hFont,FACE_NORMALBOLD);
  prt.AddTableRecord (hFont,"NAME|GRADE|CITY|ADDRESS",FORMAT_CENTER);
  //set the records
  prt.SetFace (hFont,FACE_NORMAL);
  prt.AddTableRecord (hFont,"George Papaioannou|Grade A|Athens (Greece)|23 Octobriou",FORMAT_CENTER);
  prt.AddTableRecord (hFont,"Kostas Papadimitriou|Grade B|Larissa (Greece)|Irron Polytechneiou",FORMAT_CENTER);


  // now end the page
  prt.EndPage();

  // close the print document and release it in the spooler
  prt.EndPrint();

}

void HeaderFooter(CQPrint*prt,int page,bool hf)
{

  if (hf)    // header line is wanted
  {
    prt->Print(prt->GetActiveFont(),"Header1",FORMAT_CENTER);
    prt->lf(prt->GetActiveFont(),1);
  }
  else
  {
    CSize  dim;
    CRect  margins;
    CString strBuffer;
    prt->GetDrawDimension(dim);
    prt->GetMargins(margins);
    prt->SetHPos(dim.cy-margins.bottom);
    strBuffer.Format ("Page %d",page);
    prt->Print(prt->GetActiveFont(),strBuffer,FORMAT_CENTER);
    //prt->InsertBitmap(IDB_LOGO,FORMAT_RIGHT);
  }
}
